#!/usr/bin/env python3

n = int(input())

[h1, h2, h3] = [float(x) for x in input().split(" ")]
[v1, v2, v3] = [float(x) for x in input().split(" ")]

hits = 0

n1 = h2 * v3 - v2 * h3
n2 = h3 * v1 - v3 * h1
n3 = h1 * v2 - v1 * h2

for i in range(n):
	[p1, p2, p3, d1, d2, d3] = [float(x) for x in input().split()]
	
	dProjection = d1 * n1 + d2 * n2 + d3 * n3

	if abs(dProjection) < 1e-4: continue

	pProjection = p1 * n1 + p2 * n2 + p3 * n3
	length = -pProjection / dProjection

	if length < 0: continue

	i1 = p1 + d1 * length
	i2 = p2 + d2 * length
	i3 = p3 + d3 * length

	hFactor = (i1 * h1 + i2 * h2 + i3 * h3) / (h1 * h1 + h2 * h2 + h3 * h3)
	vFactor = (i1 * v1 + i2 * v2 + i3 * v3) / (v1 * v1 + v2 * v2 + v3 * v3)

	if (hFactor * hFactor + vFactor * vFactor) < 1: hits += 1

print(hits)
